﻿
Imports System.Data.OleDb

Public Class FTestDB    ' Para todos clientes para mostrar las enlaces con las herramientas de mostrada

    Dim MiConexion As New OleDbConnection
    Dim MisDatos As New DataSet

    Dim MiComando As New OleDbCommand

    Dim CargaClienteCompleta As Boolean = False   ' Para evitar los procedimientos que dan errores si activados durante la carga.

    Private Sub BCargarAdapter_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BCargarAdapter.Click
        CargarLaTablaConAdapter()
    End Sub

    Private Sub BCargarDataReader_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BCargarDataReader.Click
        CargarLaTablaConDataReader()
    End Sub

    Private Sub ParametroConexion()

        Dim RutaYNombreDB As String = "D:\Tmp\JorgeLuis\CalorEspecifico.mdb"  ' Ruta a cambiar segun el PC
        '   MiConexion.ConnectionString = "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" & RutaYNombreDB & ";"  ' Antica Microsoft Office
        MiConexion.ConnectionString = "Provider=Microsoft.ACE.OLEDB.12.0;Data Source=" & RutaYNombreDB & ";"  ' Ejecutar en x64

    End Sub


    Private Sub CargarLaTablaConAdapter() ' con DataAdapter   Este es mas simple porque la DataTabla es creada automaticamente

        If MisDatos.Tables.Count > 0 Then  ' Para muchas pruebas
            MisDatos.Tables.Clear()
        End If

        ParametroConexion()

        Dim UnaTabla As New DataTable
        Dim Consulta As String

        Consulta = "SELECT * FROM " & "tblClientes ORDER BY Empresa"

        Dim MiAdapter As OleDbDataAdapter = New OleDbDataAdapter(Consulta, MiConexion)

        MiAdapter.Fill(UnaTabla)
        UnaTabla.TableName = "Clientes"
        MisDatos.Tables.Add(UnaTabla)

        MiAdapter.Dispose()
        MiConexion.Close()

        MostrarDatos()

    End Sub

    Private Sub CargarLaTablaConDataReader()   ' con DataReader

        If MisDatos.Tables.Count > 0 Then  ' Para muchas pruebas
            MisDatos.Tables.Clear()
        End If

        ParametroConexion()
        MiConexion.Open()

        Dim UnaTabla As New DataTable

        ' Connexion effective 
        MiComando = MiConexion.CreateCommand()
        MiComando.CommandType = CommandType.Text
        MiComando.CommandText = "SELECT * FROM " & "tblClientes ORDER BY Empresa"

        Dim UnosDatos As OleDbDataReader
        UnosDatos = MiComando.ExecuteReader()
        ' Crear colunas en  DataTabla
        For C As Integer = 0 To UnosDatos.FieldCount - 1
            UnaTabla.Columns.Add(UnosDatos.GetName(C))
        Next

        UnaTabla.TableName = "Clientes"

        Do While UnosDatos.Read
            UnaTabla.Rows.Add()
            For C As Integer = 0 To UnosDatos.FieldCount - 1
                UnaTabla.Rows(UnaTabla.Rows.Count - 1)(C) = UnosDatos.Item(C)
            Next
        Loop
        MisDatos.Tables.Add(UnaTabla)

        UnosDatos.Close()
        MiConexion.Close()

        MostrarDatos()

    End Sub

    Private Sub MostrarDatos()

        For Each C As Control In Me.Controls  ' Para muchas pruebas, es necesario de borrar anticas enlaces
            Try
                C.DataBindings.Clear()
            Catch
            End Try
        Next

        ' DataGridView
        DGVTest.DataSource = MisDatos.Tables("Clientes")

        ' ComboBox
        CBTest.DataSource = MisDatos.Tables("Clientes")
        CBTest.DisplayMember = "Empresa"
        Try    ' Try porqué no es disponible el Id con la consulta GROUP BY 
            CBTest.ValueMember = "IdCli"
        Catch
            CBTest.ValueMember = ""
        End Try

        ' ListBox
        LBTest.DataSource = MisDatos.Tables("Clientes")
        LBTest.DisplayMember = "Empresa"

        ' TextBox
        TBTest.DataBindings.Add("Text", MisDatos.Tables("Clientes"), "IdLocalidad")

        TBValueCombo.Text = CBTest.SelectedValue ' Esta linea solamente para el primer valor de TBValueCombo

        CargaClienteCompleta = True

    End Sub

    ' El bloque de gestión de lectura. Un solo procedimiente evento responde a 4 fuentes de Click : BPrimero, BAnterior, BSiguiente y BUltimo
    Private Sub LecturaCircular_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BUltimo.Click, BAnterior.Click, BSiguiente.Click, BPrimero.Click
        ' No es necesario intentar un movimiento si el DataSet no contiene ninguna tabla.
        If MisDatos.Tables.Count > 0 Then
            ' El BindingContext pertenece a un contenedor, el formulario en este caso.

            '' '' Las 2 lineas siguiente esta para evitar de registrar modificaciones accidentales. 
            '' '' No activadas aqui porque el objtecto de este ejemplo es de mostrar estos cambios.
            ' ''MisDatos.Tables(NombreTablaEnDB).RejectChanges()
            ' ''Me.BindingContext(MisDatos.Tables(NombreTablaEnDB)).CancelCurrentEdit()

            With Me.BindingContext(MisDatos.Tables("Clientes"))
                ' Modificacion de la propiedad Position segun el boton seleccionado.
                Select Case sender.Name
                    Case "BPrimero"
                        .Position = 0
                    Case "BAnterior"
                        If .Position = 0 Then
                            .Position = .Count - 1              ' Lectura circular (como un reloj pero al revés)
                        Else
                            .Position -= 1
                        End If
                    Case "BSiguiente"
                        If .Position = .Count - 1 Then
                            .Position = 0                       ' Lectura circular (como un reloj)
                        Else
                            .Position += 1
                        End If
                    Case "BUltimo"
                        .Position = .Count - 1
                End Select
            End With
        End If
    End Sub

    Private Sub CBTest_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles CBTest.SelectedIndexChanged
        If Not CargaClienteCompleta Then
            Exit Sub
        End If

        Try    ' Try porqué no es disponible el CBTest.SelectedValue con la consulta GROUP BY 
            TBValueCombo.Text = CBTest.SelectedValue
        Catch

        End Try
    End Sub

    Private Sub FTestDB_Load(sender As Object, e As EventArgs) Handles Me.Load
        '
    End Sub

    Private Sub FTestDB_FormClosed(sender As Object, e As FormClosedEventArgs) Handles Me.FormClosed
        Try
            MisDatos.Dispose()
        Catch ex As Exception

        End Try
    End Sub
End Class

